BRR_ENABLED = true
BRR_LOGGING = true
BRR_BIJOUS = true
BRR_COINS = true
local coinList = {}
local bijouList = {}
local coinsDistributed = 0
local bijousDistributed = 0
local frame = CreateFrame("FRAME", "BijouRR")
frame:RegisterEvent("LOOT_OPENED")

local function count(T)
  local count = 0
  for _ in pairs(T) do count = count + 1 end
  return count
end

local function printIfEnabled(words)
	if BRR_LOGGING then
		print(words)
	end
end

local function GetValidMasterLootMembers(li)
	local count = 0
	for ci = 1, GetNumGroupMembers() do
		local memName = GetMasterLootCandidate(li, ci)
		if memName then
			count = count + 1
		end
	end
	return count
end

local function TryToDistributeCoin(li, itemName)
	local distributed = false
	for ci = 1, 40 do
		local groupMembers = GetValidMasterLootMembers(li)
		local memName = GetMasterLootCandidate(li, ci)
		if not memName then
			return distributed
		end
		if not coinList[memName] then
			GiveMasterLoot(li, ci)
			coinList[memName] = time()
			printIfEnabled("BijouRR: Giving " .. itemName .. " to " .. memName)
			coinsDistributed = coinsDistributed + 1
			printIfEnabled("BijouRR: Completed " .. coinsDistributed .. "/" .. groupMembers)
			distributed = true
			break
		end
	end	
	return distributed
end

local function TryToDistributeBijou(li, itemName)
	local distributed = false
	for ci = 1, 40 do
		local groupMembers = GetValidMasterLootMembers(li)
		local memName = GetMasterLootCandidate(li, ci)
		if not memName then
			return distributed
		end
		if not coinList[memName] then
			GiveMasterLoot(li, ci)
			coinList[memName] = time()
			printIfEnabled("BijouRR: Giving " .. itemName .. " to " .. memName)
			bijousDistributed = bijousDistributed + 1
			printIfEnabled("BijouRR: Completed " .. bijousDistributed .. "/" .. groupMembers)
			distributed = true
			break
		end
	end	
	return distributed
end

local function eventHandler(self, event, ...)
	if BRR_ENABLED == false then
		return
	end

	local lootmethod, masterlooterPartyID, masterlooterRaidID = GetLootMethod()
    if lootmethod == "master" and masterlooterPartyID == 0 then
		for li = 1, GetNumLootItems() do
			local itemLink = GetLootSlotLink(li)
			if itemLink then
				local itemName = GetItemInfo(itemLink)
				local itemIsCoin = string.find(itemName, "Coin$")
				local itemIsBijou = string.find(itemName, "Bijou$")
				if BRR_COINS and itemIsCoin then
					local distributed = TryToDistributeCoin(li, itemName)
					if not distributed then
						printIfEnabled("BijouRR: Finished Coin Cycle, Starting Over!")
						coinsDistributed = 0
						wipe(coinList)
						TryToDistributeCoin(li, itemName)
						break
					end
				end
				if BRR_BIJOUS and itemIsBijou then
					local distributed = TryToDistributeBijou(li, itemName)
					if not distributed then
						printIfEnabled("BijouRR: Finished Bijou Cycle, Starting Over!")
						bijousDistributed = 0
						wipe(bijouList)
						TryToDistributeBijou(li, itemName)
						break
					end
				end
			end
		end
	end
end

frame:SetScript("OnEvent", eventHandler);

SLASH_BIJOURR1 = "/brr"

SlashCmdList.BIJOURR = function(input)
	input = string.lower(input)
	if input == "log" then
		BRR_LOGGING = not BRR_LOGGING
		local word = "Disabled"
		if BRR_LOGGING then
			word = "Enabled"
		end
		print("BijouRR: Logging " .. word)
		return
	elseif input == "coin" then
		BRR_COINS = not BRR_COINS
		local word = "Disabled"
		if BRR_COINS then
			word = "Enabled"
		end
		print("BijouRR: Coins " .. word)
		return	
	elseif input == "bijou" then
		BRR_BIJOUS = not BRR_BIJOUS
		local word = "Disabled"
		if BRR_BIJOUS then
			word = "Enabled"
		end
		print("BijouRR: Bijous " .. word)
		return
	elseif input == "help" then
		print("Bijou Round Robin Commands")
		print("--------------------------")
		print("Entirely Enable/Disable the Addon: /brr")
		print("Enable/Disable the Reporting of the Addon: /brr log")
		print("Enable/Disable the Distribution of Coins: /brr coin")
		print("Enable/Disable the Distribution of Bijous: /brr bijou")
	elseif input == "" then
	else
		print("BijouRR: Invalid Command, Input '/brr help' to get a list of available commands")
		return
	end

	if BRR_ENABLED then
		BRR_ENABLED = false
		print("BijouRR: Disabled")
	else
		BRR_ENABLED = true
		print("BijouRR: Enabled")
	end
end